package myHttp

func (t *Client) HasHeader(key string) bool {
	for k, _ := range t.headers {
		if key == k {
			return true
		}
	}
	return false
}

func (t *Client) SetHeaders(header map[string]string) *Client {
	t.headers = header
	return t
}

func (t *Client) AddHeader(key, value string) *Client {
	t.headers[key] = value
	return t
}

func (t *Client) AddHeaders(header map[string]string) *Client {
	for k, v := range header {
		t.headers[k] = v
	}
	return t
}

func (t *Client) DelHeader(key string) *Client {
	delete(t.headers, key)
	return t
}
